#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "get_temp_dir4xi.py">
#<abstract4xi abstract = "providing function get_temp_dir4xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'get_temp_dir4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import signal
import threading                
import _thread
import _winapi
   

import shutil
import tempfile
import itertools
import weakref
import atexit
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import get_tempdir_current_process4xi
from current_process4xi import set_tempdir_current_process4xi

from finalize4xi import Finalize4Xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-temp-dir4xi" usage = "
#   connection.py:
#       from multiprocessing.util import get_temp_dir, Finalize, sub_debug, debug
#           return tempfile.mktemp(prefix='listener-', dir=get_temp_dir())
#   arbitrary_address4xi.py:
#       dir2xi = get_temp_dir4xi()

#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def get_temp_dir4xi():
    '''
    get_temp_dir4xi function returns a temp directory which will be removed on exit 
    '''
    
    # ---------------------------------------------------------------------------------------------
    # (Step 1/3)
    # ---------------------------------------------------------------------------------------------

    class2print = "get_temp_dir4xi"
    method2print = "get_temp_dir4xi"

    message2print = "{(Step 1/3a) started" + "; get-temp-dir4xi-started: " + str(get_temp_dir4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    temp_dir2xi = get_tempdir_current_process4xi()
    
    message2print = "{(Step 1/3a) got" + "; temp-dir2xi-got-by-get-temp-dir4xi to: " + str(temp_dir2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
    
    if temp_dir2xi is None:
    
    # ---------------------------------------------------------------------------------------------
    # (Step 2/3)                            
    # ---------------------------------------------------------------------------------------------        
        tempdir2xi = tempfile.mkdtemp(prefix='pymp-')
        
        message2print = "{(Step 2/3a) set" + "; tempdir2xi-set-by-get-temp-dir4xi to: " + str(tempdir2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{(Step 2/3b) passing" + "; shutil-rmtree-passing-to-Finalize4Xi-by-get-temp-dir4xi: " + str(shutil.rmtree) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
   
        message2print = "{(Step 2/3c) passing" + "; args-passing-to-Finalize4Xi-by-get-temp-dir4xi: " + str(args) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{(Step 2/3d) passing" + "; exitpriority-passing-to-Finalize4Xi-by-get-temp-dir4xi: " + str(exitpriority) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                  
                
        try:
            Finalize4Xi(None, shutil.rmtree, args=[tempdir2xi], exitpriority=-100)
                
            message2print = "{(Step 2/3e) performed" + "; Finalize4Xi-performed-by-get-temp-dir4xi: " + str(Finalize4Xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        except:
            message2print = "{(Step 2/3f) hit" + "; Finalize4Xi-hit-by-get-temp-dir4xi: " + " *** " + str(Finalize4Xi)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
            raise
                     
        message2print = "{(Step 2/3g) passing" + "; tempdir2xi-passing-to-set-tempdir-current-process4xi-by-get-temp-dir4xi: " + str(tempdir2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
        try:
            set_tempdir_current_process4xi(tempdir2xi)

            message2print = "{(Step 2/3h) performed" + "; set-tempdir-current-process4xi-performed-by-get-temp-dir4xi: " + str(set_tempdir_current_process4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        except:
            message2print = "{(Step 2/3i) hit" + "; set-tempdir-current-process4xi-hit-by-get-temp-dir4xi: " + " *** " + str(set_tempdir_current_process4xi)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
            raise
                                     


                
                    
    # ---------------------------------------------------------------------------------------------
    # (Step 3/3)                           
    # ---------------------------------------------------------------------------------------------        
    temp_dir2xi = get_tempdir_current_process4xi()

    message2print = "{(Step 3/3) returning" + "; temp-dir2xi-returning-by-get-temp-dir4xi: " + str(temp_dir2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
    return temp_dir2xi
#</function4xi>
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

      

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of get_temp_dir4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
